// ChangeIconDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChangeIcon.h"
#include "ChangeIconDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



#define ICONFILE "C:\\MyProjects\\IconDLL\\Release\\IconDLL.Dll"
/////////////////////////////////////////////////////////////////////////////
// CChangeIconDlg dialog

CChangeIconDlg::CChangeIconDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeIconDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeIconDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChangeIconDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeIconDlg)
	DDX_Control(pDX, IDC_ICONLIST, m_listbox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChangeIconDlg, CDialog)
	//{{AFX_MSG_MAP(CChangeIconDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_LBN_SELCHANGE(IDC_ICONLIST, OnSelchangeIconlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeIconDlg message handlers

BOOL CChangeIconDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	
	HICON hIcon=NULL;
	int i=0;
	do
	{
		hIcon = ExtractIcon(AfxGetInstanceHandle(),ICONFILE,i++);
		if(hIcon!=NULL)
		{
			int iItem = m_listbox.AddIconItem(hIcon); // hIcon is put into ItemData
		}
	}
	while(hIcon!=NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChangeIconDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChangeIconDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CChangeIconDlg::OnSelchangeIconlist() 
{
	int iSelected = m_listbox.GetCurSel();
	if(iSelected!=LB_ERR)
	{
		HICON hIcon = ExtractIcon(AfxGetInstanceHandle(),ICONFILE,iSelected);
		if(hIcon!=NULL)
		{
			CStatic* pStatic = (CStatic*)GetDlgItem(IDC_SLECTEDICON);
			VERIFY(pStatic);
			pStatic->SetIcon(hIcon);
		}

	}
	
}
